mirror of
https://github.com/xomboverlord/ldc.git
synced 2026-02-28 09:33:27 +01:00
Use LLVM-style command line (instead of DMD-style)
Note: For a backward compatible interface, use the new bin/ldmd script. It
supports all old options while passing on anything it doesn't recognize.
Some changes caused by this:
* -debug and -version are now -d-debug and -d-version due to a conflict with
standard LLVM options.
* All "flag" options now allow an optional =true/=1/=false/=0 suffix.
* Some "hidden debug switches" starting with "--" were renamed because LLVM
doesn't care about the number of dashes, so they were conflicting with other
options (such as -c).
The new versions start with "-hidden-debug-" instead of "--"
* --help works, but has a non-zero exit code. This breaks some Tango scripts
which use it to test for compiler existence. See tango.patch.
Some changes not (directly) caused by this;
* (-enable/-disable)-FOO options are now available for pre- and postconditions.
* -march is used instead of -m (like other LLVM programs), but -m is an alias
for it.
* -defaultlib, -debuglib, -d-debug and -d-version allow comma-separated values.
The effect should be identical to specifying the same option multiple times.
I decided against allowing these for some other options because paths might
contain commas on some systems.
* -fPIC is removed in favor of the standard LLVM option -relocation-model=pic
Bug:
* If -run is specified as the last argument in DFLAGS, no error is generated.
(Not very serious IMHO)
This commit is contained in:
56
tango.patch
Normal file
56
tango.patch
Normal file
@@ -0,0 +1,56 @@
|
||||
Index: lib/unittest.sh
|
||||
===================================================================
|
||||
--- lib/unittest.sh (revision 4330)
|
||||
+++ lib/unittest.sh (working copy)
|
||||
@@ -15,14 +15,14 @@
|
||||
usage() {
|
||||
echo 'Usage: ./unittest.sh [otions ...]
|
||||
Options:
|
||||
- --help: This message
|
||||
+ --help: This message
|
||||
--run-all: Reports result instead of breaking. Do not use this if you want to
|
||||
- run unittest runner through a debugger.
|
||||
- dmd: Builds unittests for dmd
|
||||
- gdc: Builds unittests for gdc
|
||||
- ldc: Builds unittests for ldc
|
||||
+ run unittest runner through a debugger.
|
||||
+ dmd: Builds unittests for dmd
|
||||
+ gdc: Builds unittests for gdc
|
||||
+ ldc: Builds unittests for ldc
|
||||
|
||||
- <none>: Builds unittests for all known compilers.'
|
||||
+ <none>: Builds unittests for all known compilers.'
|
||||
exit 0
|
||||
}
|
||||
|
||||
@@ -37,7 +37,7 @@
|
||||
|
||||
rebuild --help >& /dev/null || die "rebuild required, aborting" 1
|
||||
|
||||
- if ! $DC --help >& /dev/null
|
||||
+ if ! which $DC >& /dev/null
|
||||
then
|
||||
echo "$DC not found on your \$PATH!"
|
||||
else
|
||||
Index: lib/build-tango.sh
|
||||
===================================================================
|
||||
--- lib/build-tango.sh (revision 4330)
|
||||
+++ lib/build-tango.sh (working copy)
|
||||
@@ -131,7 +131,7 @@
|
||||
DC=$1
|
||||
LIB=$2
|
||||
|
||||
- if ! $DC --help >& /dev/null
|
||||
+ if ! which "$DC" >& /dev/null
|
||||
then
|
||||
echo "$DC not found on your \$PATH!"
|
||||
return
|
||||
@@ -203,7 +203,7 @@
|
||||
build gdmd libgtango.a libgphobos.a
|
||||
;;
|
||||
ldc)
|
||||
- build ldc libtango-user-ldc.a build-tango.sh
|
||||
+ build ldmd libtango-user-ldc.a build-tango.sh
|
||||
;;
|
||||
mac)
|
||||
POSIXFLAG="-version=Posix"
|
||||
Reference in New Issue
Block a user